import { Component, OnInit, Input } from '@angular/core';
import { ActivatedRoute } from '@angular/router';
import { Location } from '@angular/common';

import { Hero } from '../hero';
import { HeroService } from '../hero.service';

@Component({
  selector: 'app-hero-detail',
  templateUrl: './hero-detail.component.html',
  styleUrls: ['./hero-detail.component.css']
})
export class HeroDetailComponent implements OnInit {

  @Input() hero: Hero;
  
  constructor(private route: ActivatedRoute, private heroService: HeroService, private location: Location) { }

  ngOnInit(): void {
    this.getHero();
  }

  async getHero(): Promise<void> {
    const id = +this.route.snapshot.paramMap.get('id');
    this.hero = await this.heroService.getHero(id)
  }

  goBack(): void {
    this.location.back();
  }

  save(): void {
    // this.heroService.updateHero(this.hero).subscribe(() => this.goBack());
  }
}
